Subject: Re: potential improvement to 'git log' with a range

From: Jakub Narebski <[email-masked]>
Date: Wed, 23 Jun 2010 23:24:31 +0200

On Wed, 23 Jun 2010, Martin Geisler wrote:
> Jakub Narebski <[email-masked]> writes:
>> On Wed, 23 Jun 2010, Martin Geisler wrote:
>>
>>> This is fixed with Mercurial 1.6: we now have a query language where
>>> 'X..Y' (or 'X::Y') is understood as the set of changesets that are
>>> both descendents of X and ancestors of Y.
>>
>> Thanks. It looks like Mercurial's 'X::Y' is equivalent to Git's
>> '--ancestry-path X..Y' (the --ancestry-path option is a new feature).
> 
> Yeah, it is equivalent to --ancestry-path. I had no idea Git's range
> operator worked the way it does :-)
> 
> For mercurial-devel: 'X..Y' is a shorthand for '^X Y', which in turn
> means ancestors of Y, excluding ancestors of X (and excluding X).

Err... so how it is for X..Y / X::Y in Mercurial?  "Ancestors of Y, 
excluding ancestors of X" is larger range (and default result for
X..Y in Git) than "descendants of X and ancestors of Y" (i.e. the
result of new --ancestry-path X..Y in Git).

See http://repo.or.cz/w/git.git/blob/refs/heads/pu:/Documentation/rev-list-options.txt#l582

>>>> [1]
>>>> http://stackoverflow.com/questions/1598759/git-and-mercurial-compare-and-contrast/1599930#1599930
>>
>> Fixed. Could you please take a look if it is correct, and if there are
>> errors, either correct it yourself, or ask me to do it (either via
>> comments for this question, or via email)? Thanks in advance.
> 
> Yes, its correct now. But would you object if I or someone else took out
> all those personal opinions and rewrote it from a neutral point of view?

Well, I do provide disclaimer upfront that I am biased towards Git, and
I have tried to be objective.

But I don't mind if someone who uses Mercurial fixed that side, and
tried for neutral point of view (but not introducing the opposite bias).
There would be problem with NPOV with issues without clear answer, where
personal preference matters, though.

>> P.S. Isn't mercurial-devel subscribe only?
> 
> No, not really -- you will be whitelisted the first time you post.

Nice.

-- 
Jakub Narebski
Poland